"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReputationFromTokenScheme = void 0;
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var operation_1 = require("../operation");
var ReputationFromTokenScheme = /** @class */ (function () {
    function ReputationFromTokenScheme(scheme) {
        this.scheme = scheme;
    }
    ReputationFromTokenScheme.prototype.getAgreementHash = function () {
        return __awaiter(this, void 0, void 0, function () {
            var contract, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getContract()];
                    case 1:
                        contract = _a.sent();
                        return [4 /*yield*/, contract.methods.getAgreementHash().call()];
                    case 2:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    ReputationFromTokenScheme.prototype.redeem = function (beneficiary, agreementHash) {
        var _this = this;
        var mapReceipt = function (receipt) {
            return receipt;
        };
        var observable = rxjs_1.from(this.getContract())
            .pipe(operators_1.concatMap(function (contract) {
            var transaction;
            var contractInfo = _this.scheme.context.getContractInfo(contract.options.address);
            var contractVersion = contractInfo.version;
            var versionNumber = Number(contractVersion.split('rc.')[1]);
            if (versionNumber <= 32) {
                transaction = contract.methods.redeem(beneficiary);
            }
            else {
                if (!agreementHash) {
                    throw Error("For ReputationForToken version > rc.32, an \"agreementHash\" argument must be provided");
                }
                transaction = contract.methods.redeem(beneficiary, agreementHash);
            }
            var errorHandler = function (error) { return __awaiter(_this, void 0, void 0, function () {
                var err_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, transaction.call()];
                        case 1:
                            _a.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            err_1 = _a.sent();
                            throw err_1;
                        case 3: return [2 /*return*/, error];
                    }
                });
            }); };
            return _this.scheme.context.sendTransaction(transaction, mapReceipt, errorHandler);
        }));
        return operation_1.toIOperationObservable(observable);
    };
    ReputationFromTokenScheme.prototype.redemptionAmount = function (beneficiary) {
        return __awaiter(this, void 0, void 0, function () {
            var contract, amount;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getContract()];
                    case 1:
                        contract = _a.sent();
                        return [4 /*yield*/, contract.methods.redeem(beneficiary).call()];
                    case 2:
                        amount = _a.sent();
                        return [2 /*return*/, amount];
                }
            });
        });
    };
    ReputationFromTokenScheme.prototype.getContract = function () {
        return __awaiter(this, void 0, void 0, function () {
            var state, contract;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.scheme.fetchStaticState()];
                    case 1:
                        state = _a.sent();
                        contract = this.scheme.context.getContract(state.address);
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    return ReputationFromTokenScheme;
}());
exports.ReputationFromTokenScheme = ReputationFromTokenScheme;
//# sourceMappingURL=reputationFromToken.js.map