import BN = require('bn.js');
import { Arc } from '../arc';
import { Proposal } from '../proposal';
import { Address } from '../types';
export interface IGenericSchemeMultiCallInfo {
    id: string;
    schemeConstraints: Address;
    contractsWhiteList: Address[];
    votingMachine: Address;
}
export interface IGenericSchemeMultiCall {
    id: string;
    contractsToCall: Address[];
    callsData: string[];
    executed: boolean;
    returnValues: string[];
    values: BN[];
}
export interface IProposalCreateOptionsGSMultiCall {
    contractsToCall?: Address[];
    callsData?: string[];
    values?: BN[];
}
export declare enum IProposalType {
    GenericSchemeMultiCall = "GenericSchemeMultiCall"
}
export declare function createTransaction(options: any, context: Arc): () => Promise<any>;
/**
 * map the transaction receipt of the createTransaction call to a nice result
 * @param  options  the options passed to the createProposal call
 * @param  context an Arc instance
 * @return         [description]
 */
export declare function createTransactionMap(options: any, context: Arc): (receipt: any) => Promise<Proposal>;
